<?php
/* v4.5 */
class Application
{

    public function run()
    {
        if (\g::request()->server()->get('REQUEST_METHOD') === 'OPTIONS') {
            die;
        }

        $_GET = \g::request()->get()->get();
        $_POST = \g::request()->post()->get();

        if (isset($_SESSION['hash_password']) && !\core\CheckLogin::is_login()) {
            unset($_SESSION['hash_password'], $_SESSION['login'], $_SESSION['lifetime']);
        }

        \g::ml()->fire(new \core\event\events\BeforeRequestEvent());
        \g::ml()->fire(new \core\event\events\GetRequestEvent($_GET));

        $routes = new \core\Router();
        if ($routes->run() === false) {
            $routes->run('404');
        }
        \g::ml()->fire(new \core\event\events\BeforeResponseEvent());

        if (
            \g::stack()->get('route') &&
            isset(\g::stack()->get('route')['modules']) &&
            \g::stack()->get('route')['modules'] === '404'
        ) {
            header("HTTP/1.0 404 Not Found");
        }

        \g::response()->header()->send();
        if (\g::request()->header()->get('x-miwix-json')) {
            \core\response\Json::run();
        } else {
            \core\response\Html::run() ?: \core\Errors::views();
        }

        \g::ml()->fire(new \core\event\events\AfterResponseEvent());
    }
}
