<?php

class ModuleAPI {

    /*
     * Если что-то нужно добавить в "Основные" пункт меню в админке, добавляем эти данные в стек
     */
    private static $mainMenuStack = [];

    /*
     * Добавит пункт в "Основные" в главном меню админки
     */
    public static function addToMainMenu($stack){
        self::$mainMenuStack[] = $stack;
    }

    public static function getMenuStack(){
        return self::$mainMenuStack;
    }

    /*
     * Module Storage, файловое хранилище каждого модуля
     */
    public static function setStorage($name, $data, $path = null){
        $full_path = ROOT.'/storage/';
        if(!is_dir($full_path)){
            mkdir($full_path, 0700, true);
			copy(ROOT."/config/.htaccess", ROOT."/storage/.htaccess");
        }
        if (!is_null($path)) {
            $full_path = $full_path.$path.'/';
            if (!is_dir($full_path)) {
                mkdir($full_path, 0700, true);
            }
        }
        file_put_contents($full_path.$name.'.data', json_encode($data));
    }

    public static function getStorage($name, $path = null){
        $full_path = ROOT.'/storage/';
        if (!is_null($path)) {
            $full_path = $full_path.$path.'/';
        }
        if(file_exists($full_path.$name.'.data')){
            return json_decode(file_get_contents($full_path.$name.'.data'), true);
        }
        return false;
    }
}
