document.querySelector('.all-helps').addEventListener('click', () => {
    document.querySelector('.job_list_block').classList.add('d-none')
    miwix_help.showAll()
})

class miwix_help {
    static object = '';
    static link = 'https://cdn.miwix.ru';
    static data = '';

    constructor() {

    }

    static loadData(all = false) {
        fetch('https://cdn.miwix.ru/getInfo/', {
            method: 'GET',
            headers: {
                'x-miwix-json': 'true'
            }
        }).then(response => response.json())
            .then((l) => {
                this.data = l.data;
                console.log(this.data);
                if (all)
                    this.showAll()
                else
                    this.show()
            })
    }

    static showAll() {
        if (this.data === '') {
            this.loadData(true);
            return false;
        }
        let html = `<input id="miwix_help_search" placeholder="Поиск..." type="text" class="form-control form-control-solid" name="name" value="">
					<a href="#" style="position:absolute; right:70px; margin-top:-30px; display:none" class="clearHelpSearch">
						<span class="svg-icon svg-icon-3"><svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
							<rect opacity="0.9" x="7.05025" y="15.5356" width="12" height="2" rx="1" transform="rotate(-45 7.05025 15.5356)" fill="currentColor"></rect>
							<rect x="8.46447" y="7.05029" width="12" height="2" rx="1" transform="rotate(45 8.46447 7.05029)" fill="currentColor"></rect>
						</svg></span></a><br><br>`;

        html += `<div id="miwix_help_body" style="text-align: left;">`;

        this.data.forEach((el) => {
            html += this.element(el)
        })

        html += `</div>`;

        this.fire(html)

        this.setOnClick();
		document.querySelector('.clearHelpSearch').addEventListener('click', (el) => {
			document.querySelector('#miwix_help_search').value = ''
			document.querySelector('.clearHelpSearch').style.display = 'none'
			this.sort()
		})
        setTimeout(() => {
            document.querySelector('#miwix_help_search').addEventListener('keyup', (el) => {
                this.sort(document.querySelector('#miwix_help_search').value)
				let length = document.querySelector('#miwix_help_search').value.length;
				if (length > 0) document.querySelector('.clearHelpSearch').style.display = 'block';
				else document.querySelector('.clearHelpSearch').style.display = 'none'
            })
        }, 200)
    }

    static sort(search = '') {
        let el = document.querySelector('#miwix_help_body');
        let height = el.clientHeight;
        let html = ``;

        this.data.forEach((el) => {
            if (el.name.toLowerCase().indexOf(search.toLowerCase()) !== -1)
                html += this.element(el)
        })
        el.innerHTML = html;
        this.setOnClick();
        el.style.height = height + 'px';
    }

    static show() {
        if (this.data === '') {
            this.loadData();
            return false;
        }
        let html = ``;

        this.data.forEach((el) => {
            html += this.element(el)
        })
        if (html === ``) {
            html = `<p class="linkPDF">Если нет ответа на ваш вопрос по работе с панелью администратора, отправьте запрос на почту: <a href="mailto:support@miwix.ru">support@miwix.ru</a> сделаем в течение 48 часов.</p>`
        }
        this.fire(html)

        this.setOnClick();
    }

    static fire(data) {
        console.log(Swal.fire({
            width: '700px',
            title: ``,
            showCloseButton: true,
            showConfirmButton: false,
            html: ` <ul class="pdfInfo" style="    padding: 0;     padding-right: 5px;">   
                <div class="">
                <p class="mt-4 text-left" style="font-size: 12px; text-align: left;">Не нашли ответ на ваш вопрос, отправьте запрос на почту: <a href="mailto:support@miwix.ru">support@miwix.ru</a> сделаем инструкцию в ближайшее время.</p>
                </div>
                ${data}       
                <div class="">
                <p class="mt-4 text-left" style="font-size: 12px; text-align: left;">Не нашли ответ на ваш вопрос, отправьте запрос на почту: <a href="mailto:support@miwix.ru">support@miwix.ru</a> сделаем инструкцию в ближайшее время.</p>
                </div>               
            </ul>`,
        }));
    }
	
    static kitcut(text, limit) {
        text = text.trim();
        if (text.length <= limit) return text;
        text = text.slice(0, limit);
        let lastSpace = text.lastIndexOf(" ");
        if (lastSpace > 0) {
            text = text.substr(0, lastSpace);
        }
        return text + "...";
    }
	
    static cutTegs(str) {
        var regex = /( |<([^>]+)>)/ig,
            result = str.replace(regex, "");

        return this.kitcut(result, 150);
    }
	
    static setOnClick() {}
	
    static element(data) {
        return `
           <div class="fs-4 fw-semibold text-info pb-1 px-2" style="color: #7239ea; font-weight: 700; font-size: 14px !important; margin-bottom: -8px; color: #7239eabd !important;">${data.name}</div>
            <div class="card card-dashed min-w-175px my-3 p-6 news_list mb-8 info-anons" style="font-size: 12px; color: #575757; margin-bottom: 2em; padding-bottom: -1rem;">
                <div class="info-text">${(data.content)}</div>
            </div>
        `;
    }
}