<!DOCTYPE html>
<html lang="ru">
<!--begin::Head-->
<head>
    <title>MIWIX | Вход в панель администратора</title>
    <meta charset="utf-8"/>
    <meta name="description" content="Miwix Login Page"/>
    <meta name="keywords" content="Miwix Login Page"/>
    <meta name="viewport" content="width=device-width, initial-scale=1"/>
    <link rel="shortcut icon" href="/miwix-admin/admin/assets/logo-2.svg"/>
    <!--begin::Fonts-->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Poppins:300,400,500,600,700"/>
    <!--end::Fonts-->
    <!--begin::Global Stylesheets Bundle(used by all pages)-->
    <link href="/miwix-admin/admin/assets/plugins/global/plugins.bundle.css" rel="stylesheet" type="text/css"/>
    <link href="/miwix-admin/admin/assets/css/style.bundle.css" rel="stylesheet" type="text/css"/>
    <style>
        #kt_body::-webkit-scrollbar {
            display: none;
        }
        #kt_body{
            box-sizing: border-box !important;
            overflow: hidden !important;
        }
        
        .launcher .sidebar {
            position: fixed;
            overflow: hidden;
            display: flex;
            flex-direction: column;
            width: 425px;
            top: 50px;
            left: 50px;
            height: fit-content;
            max-height: 90vh;
            background-color: rgba(0, 0, 0, 0.3);
            border-radius: 1.75rem;
        }

        @media(max-width: 1500px){
            .launcher .sidebar {
                width: 250px !important;
                top: 15px;
                left: 15px;
            }
        }

        @media(max-width: 1070px){
            .launcher .sidebar {
                width: 215px !important;
            }
            #kt_sidebar_header .text-white{
                font-size: calc(.8rem + .3vw);
            }
            .timeline-content .pe-3 .fs-5{
                font-size: .9rem !important;
            }
        }
        
        @media(max-width: 991px){
            .bg-body{
                width: 260px !important;
            }
        }

        @media(max-width: 740px){
            .launcher .sidebar {
                display:none;
            }
        }

        @media (max-width: 500px) {
            .menu.fw-semibold{
                font-size:7px !important;
                margin-bottom: 60px;
                position: absolute;
            }
        }
    </style>
    <!--end::Global Stylesheets Bundle-->
</head>
<!--end::Head-->
<!--begin::Body-->
<body id="kt_body" class="bg-dark">
<!--begin::Main-->
<div class="d-flex flex-column flex-root">
    <!--begin::Authentication - Sign-in -->
    <div class="page launcher sidebar-enabled d-flex flex-row flex-column-fluid me-lg-5"
         style="background-image: url(/miwix-admin/admin/assets/14-dark.png); background-position: bottom; background-size: contain; background-repeat: no-repeat">
        <!--begin::Content-->
        <div class="d-flex flex-column flex-row-fluid align-items-center">
            <div class="d-flex flex-center flex-column flex-column-fluid p-10 pb-lg-20">
                <!--begin::Logo-->
                <a href="/" class="mb-10">
                    <img alt="Logo" src="/miwix-admin/admin/assets/logo-2.svg" class="h-60px">
                </a>
                <!--end::Logo-->
                <!--begin::Wrapper-->
                <div class="w-lg-500px bg-body rounded shadow-sm p-10 p-lg-15 mx-auto">
                    <!--begin::Form-->
                    <form class="form w-100" id="kt_sign_in_form">
                        <!--begin::Heading-->
                        <div class="text-center mb-10">
                            <!--begin::Title-->
                            <h1 class="text-dark mb-3">Вход в панель администратора</h1>
                            <!--end::Title-->
                        </div>
                        <!--begin::Heading-->
                        <!--begin::Input group-->
                        <div class="fv-row mb-10">
                            <!--begin::Label-->
                            <label class="form-label fs-6 fw-bolder text-dark">Имя пользователя</label>
                            <!--end::Label-->
                            <!--begin::Input-->
                            <input class="form-control form-control-lg form-control-solid" type="text" name="username" autocomplete="off" required/>
                            <!--end::Input-->
                        </div>
                        <!--end::Input group-->
                        <!--begin::Input group-->
                        <div class="fv-row mb-10">
                            <!--begin::Wrapper-->
                            <div class="d-flex flex-stack mb-2">
                                <!--begin::Label-->
                                <label class="form-label fw-bolder text-dark fs-6 mb-0">Пароль</label>
                                <!--end::Label-->
                            </div>
                            <!--end::Wrapper-->
                            <!--begin::Input-->
                            <input class="form-control form-control-lg form-control-solid" type="password" name="password" autocomplete="off" required/>
                            <!--end::Input-->
                            <a onclick="recovery()" href="javascript:();">Забыл пароль</a>
                        </div>
                        <!--end::Input group-->
                        <!--begin::Actions-->
                        <div class="text-center">
                            <!--begin::Submit button-->
                            <button type="submit" id="kt_sign_in_submit" class="btn btn-lg btn-primary w-100 mb-5">
                                <span class="indicator-label">Войти</span>
                                <span class="indicator-progress">Подождите...
									<span class="spinner-border spinner-border-sm align-middle ms-2"></span>
								</span>
                            </button>
                            <!--end::Submit button-->
                        </div>
                        <!--end::Actions-->
                    </form>
                    <!--end::Form-->
                </div>
                <!--end::Wrapper-->
            </div>
            <div class="d-flex flex-column-auto flex-center">
                <!--begin::Navs-->
                <ul class="menu fw-semibold order-1">
                    <li class="menu-item">
                        <span class="menu-link text-white opacity-50  px-3" style="cursor: auto !important;">© 2009 - <?=date('Y');?> MIWIX</span>
                    </li>
                    <li class="menu-item">
                        <a href="https://web-vdv.ru/cms-miwix/miwix-oferta/" target="_blank" class="menu-link text-white opacity-50 opacity-100-hover px-3">Договор оферты</a>
                    </li>
                    <li class="menu-item">
                        <a href="https://web-vdv.ru/contacts/" target="_blank" class="menu-link text-white opacity-50 opacity-100-hover px-3">Разработчик CMS MIWIX: WEB-VDV</a>
                    </li>
                </ul>
                <!--end::Navs-->
            </div>
        </div>
        <div id="kt_sidebar" class="sidebar px-5 py-5 py-lg-8 px-lg-11" data-kt-drawer-name="sidebar"
             data-kt-drawer-activate="{default: true, lg: false}" data-kt-drawer-overlay="true"
             data-kt-drawer-width="375px" data-kt-drawer-direction="end" data-kt-drawer-toggle="#kt_sidebar_toggle">
            <!--begin::Header-->
            <div class="d-flex flex-stack mb-5 mb-lg-8" id="kt_sidebar_header">
                <!--begin::Title-->
                <h2 class="text-white">Добро пожаловать на страницу входа MIWIX!</h2>
            </div>
            <!--end::Header-->
            <!--begin::Body-->
            <div class="" id="kt_sidebar_body">
                <!--begin::Scroll-->
                <div class="hover-scroll-y me-n6 pe-6" id="kt_sidebar_body" data-kt-scroll="true"
                     data-kt-scroll-dependencies="#kt_sidebar_header, #kt_sidebar_footer"
                     data-kt-scroll-wrappers="#kt_page, #kt_sidebar, #kt_sidebar_body" data-kt-scroll-offset="0">
                    <!--begin::Timeline items-->
                    <div class="timeline">
                        <!--begin::Timeline item-->
                        <div class="timeline-item">
                            <div class="timeline-content mt-n1 mb-0">
                                <!--begin::Timeline heading-->
                                <div class="pe-3">
                                    <!--begin::Title-->
                                    <div class="fs-5 fw-semibold text-white opacity-50">Если обнаружите ошибку или
                                        посчитаете некоторые функции неудобными, пишите на email: <a href="mailto:support@miwix.ru">support@miwix.ru</a> Внесем
                                        исправления, рассмотрим ваши пожелания. Мы работаем для Вас!
                                    </div>

                                </div>
                            </div>
                            <!--end::Timeline content-->
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!--end::Authentication - Sign-in-->
</div>
<!--end::Main-->
<script type="text/javascript">var hostUrl = "/miwix-admin/admin/assets/";</script>
<script type="text/javascript">
    function recovery()
    {

        let url = '/passwordRecovery';
        fetch(url, {
            method: 'POST',
            headers: {
                'x-miwix-json': 'true'
            }
        }).then(response => response.json())
            .then((l) => {
                let icon = 'success';
                if (!l['res'])
                {
                    icon = 'error'
                }
                Swal.fire({
                    text: l['message'],
                    'icon': icon,
                    showConfirmButton: false,
                    timer: 5000
                });


            });

    }
</script>
<!--begin::Javascript-->
<!--begin::Global Javascript Bundle(used by all pages)-->
<script type="text/javascript" src="/miwix-admin/admin/assets/plugins/global/plugins.bundle.js"></script>
<script type="text/javascript" src="/miwix-admin/admin/assets/js/scripts.bundle.js"></script>
<!--end::Global Javascript Bundle-->
<!--begin::Page Custom Javascript(used by this page)-->
<script type="text/javascript" src="/miwix-admin/admin/assets/js/custom/authentication/sign-in/general.js"></script>
<!--end::Page Custom Javascript-->
<!--end::Javascript-->
</body>
<!--end::Body-->
</html>