<?php
namespace core;

class Images
{
	private $dir_list = [];

	public function __construct() {
		$this->dir_list = include ROOT . '/config/files_config.php';
	}

	public function preview($src, $size='300') {
		if (empty($src)) return false;
		return dirname($src).'/'.$size.'/'.basename($src);
	}

	public function first($str) {
		if (empty($str)) return false;
		$src = array_values(array_filter(explode('|', $str)));
		return (isset($src[0])) ? $src[0] : '';
	}

	public function firstPreview($str, $size='300') {
		if (empty($str)) return false;
		return self::preview($this->first($str), $size);
	}

	public function roll($str) {
		$images = [];
		if (empty($str)) {
			$images[] = '/files/not_images/97c39de66c3058c217cf6adc9981e651.png';
		} else {
			foreach (array_filter(explode('|', $str)) as $img) {
				if (!is_file(ROOT.$img))
					$images[] = '/files/not_images/97c39de66c3058c217cf6adc9981e651.png';
				else
					$images[] = $img;
			}
		}
		return $images;
	}

	public function render($row, $gen = true) {
		$alt = $row['name_abbr'];
		$title = $row['title'];
		
		$images = $this->roll($row['images']);
		
        if ($gen) \g::ml() -> fire(new \core\event\events\BeforeImageRenderEvent($images));

		foreach($images as $index => $src) {
			$row['img'][$index]['original'] = $src;
			$info = pathinfo($row['img'][$index]['original']);

			foreach ($this->dir_list as $key => $dir) {
				$row['img'][$index][$key] = is_file(ROOT.($file = $this->firstPreview($src, $dir['name']))) ? $file : $src;
				$info = pathinfo($row['img'][$index][$key]);
			}
			$row['img'][$index]['alt'] = $alt;
			$row['img'][$index]['title'] = $title;

			$row = \f::replaceTags($row);
		}
		return $row;
	}
}
