<?php

namespace core;

class PreRenderAdmin
{
    private static $instans = NULL;

    private $content = '';
    private $moduleContent = '';
    private $chunk_dir = ROOT . '/miwix-admin/admin/chunk/';
    private $moduleInfo = [
        'title' => '',
        'desc' => '',
        'name' => ''
    ];

    protected function __construct()
    {

    }

    public static function getInstans(): PreRenderAdmin
    {
        if (!self::$instans) {
            self::$instans = new PreRenderAdmin();
        }
        return self::$instans;
    }

    private function getContent($path)
    {
        if (file_exists($path)) {
            ob_start();
            require $path;
            $this->content = ob_get_clean();
        }
    }

    private function getChunks($name)
    {
        $path = $this->chunk_dir . $name . '.php';
        if (file_exists($path)) {
            ob_start();
            require $path;
            $content = ob_get_clean();
            $this->renderChunks($content);
            return $content;
        }
    }

    private function renderChunks(&$content)
    {
        if (preg_match_all("|\{% *:(.*)%\}|U", $content, $matches, PREG_PATTERN_ORDER)) {
            foreach ($matches[1] as $original_name) {
                $name = trim($original_name);

                $result = $this->getChunks($name);

                $content = preg_replace("/\{% *:" . $original_name . "%\}/", $result, $content);
            }
        }
    }

    private function getCurrentModule()
    {
        if (!is_null(\g::ml()->getModuleInfo(\g::stack()->get('route')['modules'])))
            return \g::stack()->get('route')['modules'];
        return null;
    }

    private function renderContent()
    {
        if (\g::stack()->get('route')['modules'] == 'main') {
            $this->moduleContent = $this->getChunks('main');
            $this->moduleInfo['title'] = 'Добро пожаловать, в систему управления MIWIX';
            return;
        } else {
            $template = '';
            $tmp = \g::getModuleTemplateInfo(\g::stack()->get('route')['modules']);
            $this->moduleInfo['desc'] = \g::ml()->getModuleInfo(\g::stack()->get('route')['modules'])['description'];
            $this->moduleInfo['name'] = \g::ml()->getModuleInfo(\g::stack()->get('route')['modules'])['name'];
            $this->moduleInfo['title'] = $tmp['name'] ??= "Настройки";

            if (isset(\g::stack()->get("route")['tpl'])) {
                $template = str_replace('.', '/', \g::stack()->get("route")['tpl']);
            } else {
                $template = str_replace('.', '/', $tmp['template'] ??= "");
            }
            if (\core\CheckLogin::is_access_method(lcfirst(\g::stack()->get('route')['modules']))) {
                $adminContent = \g::tp()->getAdminPage(\g::stack()->get('route')['modules'], $template, false);
            } else {
                $adminContent = 'Доступ запрещен';
            }

            $this->moduleContent = $adminContent;
            return;
        }
    }

    public function renderContentVars()
    {

        if (preg_match_all("|\{%(.*)%\}|U", $this->content, $matches, PREG_PATTERN_ORDER)) {
            foreach ($matches[1] as $name) {
                $res = $name;
                switch (trim($name)) {
                    case "title":
                        $res = $this->moduleInfo['title'];
                        break;
                    case "content":
                        $res = $this->moduleContent;
                        break;
                    case "title_module":
                        $res = $this->moduleInfo['name'];
                        break;
                    case "description_module":
                        $res = $this->moduleInfo['desc'];
                        break;
                    case "settings":
                        $res = $this->settingsButton();
                        break;
                }

                $this->content = preg_replace("/\{%" . $name . "%\}/", $res, $this->content);
            }
        }
    }

    public function settingsButton()
    {
        $module = \g::ml()->getModuleInfo(\g::stack()->get('route')['modules']);

        if (isset($module['settings']) && !strlen(\g::stack()->get('route')['action'])) {
            return   '
                    <div class="button_setting" onclick="OpenSettings()">
                        <svg height="30px" width="30px" viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg">
                            <defs>
                                <style>.cls-1 {
                                        fill: #5867DD;
                                    }</style>
                            </defs>
                            <title></title>
                            <g data-name="Layer 10" id="Layer_10">
                                <path class="cls-1" d="M17,31H15a3,3,0,0,1-3-2.64,12.68,12.68,0,0,1-1.95-.8,3,3,0,0,1-4-.25L4.69,25.9a3,3,0,0,1-.25-4A12.68,12.68,0,0,1,3.64,20,3,3,0,0,1,1,17V15a3,3,0,0,1,2.64-3,12.68,12.68,0,0,1,.8-1.95,3,3,0,0,1,.25-4L6.1,4.69a3,3,0,0,1,4-.25A12.68,12.68,0,0,1,12,3.64,3,3,0,0,1,15,1h2a3,3,0,0,1,3,2.64,12.68,12.68,0,0,1,1.95.8,3,3,0,0,1,4,.25L27.31,6.1a3,3,0,0,1,.25,4,12.68,12.68,0,0,1,.8,1.95A3,3,0,0,1,31,15v2a3,3,0,0,1-2.64,3,12.68,12.68,0,0,1-.8,1.95,3,3,0,0,1-.25,4L25.9,27.31a3,3,0,0,1-4,.25,12.68,12.68,0,0,1-1.95.8A3,3,0,0,1,17,31ZM9.91,25.33a.94.94,0,0,1,.51.14,11,11,0,0,0,2.83,1.17,1,1,0,0,1,.75,1V28a1,1,0,0,0,1,1h2a1,1,0,0,0,1-1v-.39a1,1,0,0,1,.75-1,11,11,0,0,0,2.83-1.17,1,1,0,0,1,1.21.15l.28.28a1,1,0,0,0,1.42,0l1.41-1.41a1,1,0,0,0,0-1.42l-.28-.28a1,1,0,0,1-.15-1.21,11,11,0,0,0,1.17-2.83,1,1,0,0,1,1-.75H28a1,1,0,0,0,1-1V15a1,1,0,0,0-1-1h-.39a1,1,0,0,1-1-.75,11,11,0,0,0-1.17-2.83,1,1,0,0,1,.15-1.21l.28-.28a1,1,0,0,0,0-1.42L24.49,6.1a1,1,0,0,0-1.42,0l-.28.28a1,1,0,0,1-1.21.15,11,11,0,0,0-2.83-1.17,1,1,0,0,1-.75-1V4a1,1,0,0,0-1-1H15a1,1,0,0,0-1,1v.39a1,1,0,0,1-.75,1,11,11,0,0,0-2.83,1.17,1,1,0,0,1-1.21-.15L8.93,6.1a1,1,0,0,0-1.42,0L6.1,7.51a1,1,0,0,0,0,1.42l.28.28a1,1,0,0,1,.15,1.21,11,11,0,0,0-1.17,2.83,1,1,0,0,1-1,.75H4a1,1,0,0,0-1,1v2a1,1,0,0,0,1,1h.39a1,1,0,0,1,1,.75,11,11,0,0,0,1.17,2.83,1,1,0,0,1-.15,1.21l-.28.28a1,1,0,0,0,0,1.42L7.51,25.9a1,1,0,0,0,1.42,0l.28-.28A1,1,0,0,1,9.91,25.33Z"></path>
                                <path class="cls-1" d="M16,23a7,7,0,1,1,7-7A7,7,0,0,1,16,23Zm0-12a5,5,0,1,0,5,5A5,5,0,0,0,16,11Z"></path>
                            </g>
                        </svg>
                    </div>
            
            ';
        }
        return '';
    }

    public function runRender($path)
    {
        $this->renderContent();
        $this->getContent($path);
        $this->renderChunks($this->content);
        $this->renderContentVars();
        echo $this->content;
    }


}