<?php
namespace core;

use \core\CheckLogin;

class Router
{
	public $errors;
	protected $url;

	public function run($url = false) {
        if ($url === false)
        {
            $uri = preg_replace("/\?.*/i",'', $_SERVER['REQUEST_URI']);
            $this->url = explode('/', \g::request()->server()->getUrl());
        } else {
            $uri = '/404/';
            $this->url = [$url];
        }
		if (strlen($uri) > 1 && !\g::request()->header()->get('x-miwix-json') && $this -> url[0] != 'miwix') {
			if (rtrim($uri, '/')."/" != $uri) {
				header("HTTP/1.1 301 Moved Permanently");
				header('Location: https://'.$_SERVER['SERVER_NAME'].str_replace($uri, $uri.'/', $_SERVER['REQUEST_URI']));
				exit();
			}
		}
		
		if ($this->url[0] === 'miwix') {
			\g::stack()->set('system', ['admin' => true]);
			\g::stack()->set('route', ['type' => 'admin']);

			if (isset($this->url[1]) && $this->url[1] == 'login') {
	            if (CheckLogin::is_login()) {

	                header("Location: /miwix/");
	                die;
	            }
	            $res = CheckLogin::auth();
	            if (empty($res)) {

					if (\g::request()->header()->get('x-miwix-json')) {
						\g::response()->data()->set(['res' => false, 'message' => 'Неверный логин или пароль']);
						\core\response\Json::run();
					} elseif (\g::request()->header()->get('referer')) {
						header('Location: ' . \g::request()->header()->get('referer'));
					} else {
						header('Location: /');
					}
	            } else {
					\g::__callStatic('AdminLogs')->WriteLog('Авторизация в админпанели');
					if (\g::request()->header()->get('x-miwix-json')) {
						\g::response()->data()->set(['res' => true, 'location' => '/miwix/']);
						\core\response\Json::run();
					} else {
						header('Location: /miwix/');
					}
	                die;
	            }
	        } else {

	            if (\g::request()->get()->get('exit') && \g::request()->get()->get('exit') == 1) {
	                $res = CheckLogin::exitAdmin();
					header('Location: /');
					die;
	            }
	            if (CheckLogin::is_login()) {
	                return $this->adminRouter();
	            }

	            if (CheckLogin::is_secret_admin()) {
	            	\g::stack()->set('route', [
	                    'modules' => 'login',
	                    'action' => 'login'
	                ]);
	                return true;
	            }

	        }
		} else {
			\g::stack()->set('route', ['type' => 'users']);
			return $this->usersRouter();
		}
	}

	private function login() {
		\g::stack()->set('route', ['modules' => 'login']);
		\g::stack()->set('route', ['action' => 'login']);
	}

	private function adminRouter() {
        $route = [];
		if (count($this->url) > 1) {
            $route['modules']  = $this->actionReplace($this->url[1]);
			if (isset($this->url[2]) && is_numeric($this->url[2])) {
				if (isset($this->url[3]))
                    $route['action'] = $this->actionReplace($this->url[3]);
				else
                    $route['action'] = "";
                $route['param'] = $this->url[2];
			} elseif (isset($this->url[2]))
                $route['action'] = $this->actionReplace($this->url[2]);
			else
                $route['action'] = "";
		} else {
            $route['modules'] = 'main';
            $route['action'] = 'main';
		}



        \g::stack()->set('route', $route);

        $BeforeRoute = new \core\event\events\BeforeRouteEvent($route);
        \g::ml()->fire($BeforeRoute);
        if($BeforeRoute->isError()){
            return false;
        }

		$event = new \core\event\events\RouteEvent(\g::stack()->get('route'));
		\g::ml()->fire($event);
		if($event->isError()){
			return false;
		}
		return true;
	}

	private function usersRouter() {
		$route = [];

		$route['modules'] = $this->url[0];
		if (isset($this->url[1])) {
			$route['action'] = $this->actionReplace($this->url[1]);
		} else {
			$route['action'] = 'main';
		}
		$route['param'] = end($this->url);


		\g::stack()->set('route', $route);
        $BeforeRoute = new \core\event\events\BeforeRouteEvent($route);
        \g::ml()->fire($BeforeRoute);
        if($BeforeRoute->isError()){
            return false;
        }

		$event = new \core\event\events\RouteEvent(\g::stack()->get('route'));
		//blackbox
		\g::ml()->fire($event);
		if ($event->isError()) {
			return false;
		}
		return true;
	}

	public static function actionReplace($action) {
		$a = '';
		$e = explode('-', $action);
		if (count($e) < 2) {
			return $e[0];
		}

		foreach($e as $k => $v) {
			if ($k < 1) {
				$a .= $v;
			} else {
				$a .= ucfirst($v);
			}
		}
		return $a;
	}
}
