<?php

namespace core\event\events;

class AfterCartOrderEvent extends \core\event\Event {

	private $order_id;
	private $cart;
	private $fields;
    private $isPay;
    private $redirectUrl;

    public function __construct($order_id, $cart, $fields, $isPay = false) {
    	$this->order_id = $order_id;
    	$this->cart = $cart;
    	$this->fields = $fields;
        $this->isPay = (bool) $isPay;
    }

    public function getEventName() {
        return "AfterCartOrderEvent";
    }

    public function getOrderId() {
    	return $this->order_id;
    }

    public function getCart() {
    	return $this->cart;
    }

    public function getFields() {
    	return $this->fields;
    }

    public function isPay(): bool {
        return $this->isPay;
    }

    public function setRedirectUrl($url) {
        $this->redirectUrl = $url;
    }

    public function getRedirectUrl() {
        return $this->redirectUrl;
    }
}
