<?php

namespace core\event\events;

class BeforeRouteEvent extends \core\event\Event {

    private $route;
    private $error = false;
    private $cancelled = false;
    private $isAdmin = false;
    private $defaultRenderStop = false;


    public function __construct($route) {
        $this->route = $route;
        if (isset($this->route['type']) && $this->route['type'] === 'admin') {
            $this->isAdmin = true;
        }
    }

    public function isRenderStopped(){
        return $this->defaultRenderStop;
    }

    public function stopDefaultRender(){
        $this->defaultRenderStop = true;
    }

    public function getEventName() {
        return "BeforeRouteEvent";
    }

    public function setCancelled($bool){
        $this->cancelled = $bool;
    }

    public function isCancelled(){
        return $this->cancelled;
    }

    public function setError($bool){
        $this->error = $bool;
    }

    public function isError(){
        return $this->error;
    }

    public function isAdmin() {
        return $this->isAdmin;
    }

    public function getRoute(){
        return $this->route;
    }

}
