<?php
namespace core\request;

class Post extends \core\Request
{
	public function __construct() {
		$meta =
			[
				'title'       => '',
				'keywords'    => '',
				'description' => '',
			];
		if (!empty($_POST)) {
			foreach ($_POST as $key => $value) {
				if (is_array($value)) {
					$this->_stack[$key] = \g::validate()->array($value);
				} else {
					if (isset($meta[$key])) {
						// $value = strtr($value, ['"' => '', '\'' => '']);
						// $value = htmlspecialchars($value);
					}
					if ($key === 'keywords') {
						$this->_stack[$key] = \g::validate()->onlyLetters($value);
					} else {
						$this->_stack[$key] = \g::validate()->string($value);	
					}
				}
			}
		}
	}

	public function sendErrors() {
		if ($this->isErrors()) {
			$message = '';
			foreach ($this->errors as $key => $error) {
				$message .= $error['message']."\n\r";
			}
			return $message;
		}
		return 'Ошибок не найдено';
	}
}
