<?php

class f
{
    private static $mask = [
        'name',
        'name_abbr',
        'title',
        'keywords',
        'description',
        'anons'
    ];

    public static function clearSettings()
    {
        $num = \g::db()->getRow('SELECT COUNT(*) AS `count` FROM `settings` WHERE `name`="last_modified" LIMIT 1');
        if ($num['count'] == 0)
            $res = \g::db()->query('INSERT INTO `settings` (`name`, `val`) VALUES ("last_modified", "")');
        $res = \g::db()->query('UPDATE `settings` SET `val`=?s WHERE `name`="last_modified"', time());
        if ($res)
            return true;
        return false;
    }

	public static function readCache($prefix, $caches = false)
	{
		if (!is_dir(ROOT."/cache")) return false;
		$file = $prefix.(($caches != false) ? "_".md5( $caches ) : "");
		$buffer = false;
		if (file_exists( ROOT . "/cache/".$file.".tmp")) {
			$buffer = file_get_contents( ROOT . "/cache/".$file.".tmp" );
		}
		if ( $buffer !== false ) {

			$file_date = filemtime( ROOT . "/cache/".$file.".tmp" );
			$file_date = time()-$file_date;

			if ( $file_date > 86400 ) {
				$buffer = false;
				unlink( ROOT . "/cache/".$file.".tmp" );
			}
			return $buffer;

		} else return $buffer;
	}

	public static function createCache($prefix, $cache_text, $caches = false)
	{
		
		$file = $prefix.(($caches != false) ? "_".md5( $caches ) : "");
		
		if($cache_text === false) $cache_text = '';
		
		if (!is_dir(ROOT."/cache")) {
			mkdir(ROOT."/cache", 0700, true);
			copy(ROOT."/config/.htaccess", ROOT."/cache/.htaccess");
		}
			
		file_put_contents (ROOT . "/cache/".$file.".tmp", $cache_text, LOCK_EX);
		
		return true;
	}

	public static function clearCache($cache_files = false)
	{
		
		if (!is_dir(ROOT."/cache")) {
			mkdir(ROOT."/cache", 0700, true);
			copy(ROOT."/config/.htaccess", ROOT."/cache/.htaccess");
		}
		
		if ( $cache_files ) {
			if(!is_array($cache_files)) {
				$cache_files = array($cache_files);
			}
		}
		$fdir = opendir( ROOT . '/cache' );
		while ( $file = readdir( $fdir ) ) {
			if( $file != '.htaccess' AND !is_dir($file) ) {
				if( $cache_files ) {
					foreach($cache_files as $cache_file) {
						if( stripos( $file, $cache_file ) === 0 ) {
							unlink( ROOT . "/cache/".$file );
						}
					}
				} else {
					unlink( ROOT . "/cache/".$file );
				}
			}
		}
		return true;
	}

	public static function wordRender($f1, $f2, $f3, $v)
	{
		$v = str_pad((int)$v, 2, '0', STR_PAD_LEFT);
		$s2 = intval(substr($v, -2, 1));
		$s1 = intval(substr($v, -1, 1));
		if ($s2 == 1 || $s1 == 0 || ($s1 > 4 && $s1 <= 9)) return $f3;
		if ($s1 == 1) return $f1;
		if ($s1 >= 2 && $s1 <= 4) return $f2;
	}

    public static function response($r, $m)
    {
        echo json_encode(['result' => $r, 'message' => $m]);
        die();
    }

    public static function responseJson($data)
    {
        echo json_encode($data);
        die();
    }

    public static function defaultRespose()
    {
    }

    public static function translitIt($url)
    {
        $url = trim($url);
        $tr = array(
            "А" => "a", "Б" => "b", "В" => "v", "Г" => "g", "Д" => "d",
            "Е" => "e", "Ё" => "yo", "Ж" => "j", "З" => "z", "И" => "i",
            "Й" => "y", "К" => "k", "Л" => "l", "М" => "m", "Н" => "n",
            "О" => "o", "П" => "p", "Р" => "r", "С" => "s", "Т" => "t",
            "У" => "u", "Ф" => "f", "Х" => "h", "Ц" => "c", "Ч" => "ch",
            "Ш" => "sh", "Щ" => "sch", "Ъ" => "", "Ы" => "yi", "Ь" => "",
            "Э" => "e", "Ю" => "yu", "Я" => "ya", "а" => "a", "б" => "b",
            "в" => "v", "г" => "g", "д" => "d", "е" => "e", "ё" => "yo", "ж" => "j",
            "з" => "z", "и" => "i", "й" => "y", "к" => "k", "л" => "l",
            "м" => "m", "н" => "n", "о" => "o", "п" => "p", "р" => "r",
            "с" => "s", "т" => "t", "у" => "u", "ф" => "f", "х" => "h",
            "ц" => "c", "ч" => "ch", "ш" => "sh", "щ" => "sch", "ъ" => "y",
            "ы" => "y", "ь" => "", "э" => "e", "ю" => "yu", "я" => "ya",
            " " => "-", "." => "", "/" => "-"
        );

        $urlstr = strtr($url, $tr);
        $urlstr = preg_replace('/[^A-Za-z0-9_\-]/', '', $urlstr);
        $urlstr = preg_replace('/-{1,}/', '-', $urlstr);

        return mb_strtolower($urlstr, 'UTF-8');
    }

    public static function transliterateen_rus($input)
    {
        $input = trim($input);
        $gost = array(
            "a" => "а", "b" => "б", "v" => "в", "g" => "г", "d" => "д", "e" => "е", "yo" => "ё",
            "j" => "ж", "z" => "з", "i" => "и", "i" => "й", "k" => "к",
            "l" => "л", "m" => "м", "n" => "н", "o" => "о", "p" => "п", "r" => "р", "s" => "с", "t" => "т",
            "y" => "у", "f" => "ф", "h" => "х", "c" => "ц",
            "ch" => "ч", "sh" => "ш", "i" => "ы", "e" => "е", "u" => "у", "ya" => "я", "A" => "А", "B" => "Б",
            "V" => "В", "G" => "Г", "D" => "Д", "E" => "Е", "Yo" => "Ё", "J" => "Ж", "Z" => "З", "I" => "И", "I" => "Й", "K" => "К", "L" => "Л", "M" => "М",
            "N" => "Н", "O" => "О", "P" => "П",
            "R" => "Р", "S" => "С", "T" => "Т", "Y" => "Ю", "F" => "Ф", "H" => "Х", "C" => "Ц", "Ch" => "Ч", "Sh" => "Ш",
            "Sh" => "Щ", "I" => "Ы", "E" => "Е", "U" => "У", "Ya" => "Я", "'" => "ь", "'" => "Ь", "''" => "ъ", "''" => "Ъ", "j" => "ї", "i" => "и", "g" => "ґ",
            "ye" => "є", "J" => "Ї", "I" => "І",
            "G" => "Ґ", "YE" => "Є"
        );
        return mb_strtolower(strtr($input, $gost));
    }

    public static function transliterateen_eng($input)
    {
        $input = trim($input);
        $gost = array(
            "а" => "a", "б" => "b", "в" => "v", "г" => "g", "д" => "d",
            "е" => "e", "ё" => "yo", "ж" => "j", "з" => "z", "и" => "i",
            "й" => "i", "к" => "k", "л" => "l", "м" => "m", "н" => "n",
            "о" => "o", "п" => "p", "р" => "r", "с" => "s", "т" => "t",
            "у" => "u", "ф" => "f", "х" => "h", "ц" => "c", "ч" => "ch",
            "ш" => "sh", "щ" => "sh", "ы" => "i", "э" => "e", "ю" => "u",
            "я" => "ya",
            "А" => "A", "Б" => "B", "В" => "V", "Г" => "G", "Д" => "D",
            "Е" => "E", "Ё" => "Yo", "Ж" => "J", "З" => "Z", "И" => "I",
            "Й" => "I", "К" => "K", "Л" => "L", "М" => "M", "Н" => "N",
            "О" => "O", "П" => "P", "Р" => "R", "С" => "S", "Т" => "T",
            "У" => "Y", "Ф" => "F", "Х" => "H", "Ц" => "C", "Ч" => "Ch",
            "Ш" => "Sh", "Щ" => "Sh", "Ы" => "I", "Э" => "E", "Ю" => "U",
            "Я" => "Ya",
            "ь" => "", "Ь" => "", "ъ" => "", "Ъ" => "",
            "ї" => "j", "і" => "i", "ґ" => "g", "є" => "ye",
            "Ї" => "J", "І" => "I", "Ґ" => "G", "Є" => "YE"
        );
        return mb_strtolower(strtr($input, $gost), 'UTF-8');
    }

    public static function gallery($name, $limit = 6)
    {
        $rows = [];
        $dir_list = include ROOT . '/config/files_config.php';
        $img = new \core\Images;
        $name = addslashes(strip_tags($name));
        $query = \g::db()->query("
			SELECT `g`.*
			FROM `gallery_main` AS `gm`
			INNER JOIN `gallery` AS `g` ON `g`.`gid` = `gm`.`id`
			WHERE `gm`.`name` = ?s
			LIMIT ?i",
            $name, $limit
        );
        if ($query->num_rows > 0) {
            while ($row = $query->fetch_assoc()) {
                $src = is_file(ROOT . $row['src']) ? $row['src'] : '/files/not_images/97c39de66c3058c217cf6adc9981e651.png';
                foreach ($dir_list as $key => $dir) {
                    $row['img'][$key] = is_file(ROOT . ($file = $img->firstPreview($src, $dir['name']))) ? $file : $src;
                }
                $row['img']['original'] = $src;
                $rows[] = $row;
            }
        }
        return $rows;
    }

    public static function section($name)
    {
        $content = '';
        $res = [];

        $query = \g::db()->query("SELECT `content` FROM `section` WHERE `name` = ?s LIMIT 1", $name);
        if ($query->num_rows > 0) {
            $value = $query->fetch_row()[0];
            if (preg_match_all("|\[s\[_(.*)_\]s\]|U", $value, $r, PREG_PATTERN_ORDER)) {
                foreach ($r[1] as $k => $v) {
                    $res[] = $v;
                }
                $value = $res[array_rand($res)];
                $query = \g::db()->query('SELECT `content` FROM `section` WHERE `name`=?s LIMIT 1', $value);
                if ($query->num_rows > 0) {
                    $content = $query->fetch_row()[0];
                }
            } else {
                $content = $value;
            }
        }
        return stripcslashes(htmlspecialchars_decode(self::mask($content)));
    }

    public static function mask($content)
    {
        foreach (self::$mask as $v) {
            if (preg_match("|%$v%|U", $content)) {
                $content = str_replace("%$v%", \g::response()->data()->get($v), $content);
            }
        }
        return $content;
    }

    public static function replaceTags($row)
    {
        if (isset($row['img'])) {
            $alt = \g::settings('alt_tag_mask');
            $title = \g::settings('title_tag_mask');
            $count = count($row['img']);
            foreach ($row['img'] as $key => $img) {
                $return = [
                    'TITLE' => $row['name'],
                    'SHORT_TITLE' => $row['name_abbr'],
                    'META_TITLE' => $row['title'],
                    'META_KEYWORDS' => $row['keywords'],
                    'META_DESCRIPTION' => $row['description'],
                    'NUMBER' => ($count > 0) ? $key + 1 : '',
                ];

                foreach ($return as $tag => $value) {
                    $value = str_replace('"', '', $value);
                    $alt = str_replace('%' . $tag . '%', $value, $alt);
                    $title = str_replace('%' . $tag . '%', $value, $title);
                }
                $row['img'][$key]['alt'] = $alt;
                $row['img'][$key]['title'] = $title;
            }
            return $row;
        }
    }

    public static function parsUrl()
    {
        return ($url = trim(urldecode(parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH)), '/')) == '' ? 'index' : $url;
    }

    public static function moneyFormat($number)
    {
        return number_format($number, self::$_afterComma, ',', ' ');
    }

    public static function generateUrl($url, $prefix)
    {
        return $url === 'index' ? '/' : (empty($prefix) ? '/' . $url . '/' : '/' . $prefix . '/' . $url . '/');
    }

    public static function replacementXML($arg)
    {
        $arg = trim($arg);
        $arg = strip_tags($arg);
        $arg = stripslashes($arg);
        $arg = str_replace(' ', ' ', $arg);
        $arg = str_replace('&nbsp;', ' ', $arg);
        $arg = str_replace('$', "&#36;", $arg);
        $arg = str_replace("&", '&#38;', $arg);
        $arg = str_replace("'", '&#39;', $arg);
        $arg = str_replace("{", '', $arg);
        $arg = str_replace("}", '', $arg);
        return $arg;
    }

    public static function sqlEscapeString($value)
    {
        $value = str_replace(';', '', $value);
        $value = str_replace('`', '', $value);
        $value = str_replace('"', '', $value);
        $value = str_replace('\'', '', $value);
        $value = mysqli_real_escape_string(\g::db()->conn, $value);
        return trim($value);
    }

    public static function curl_json($url, $method = 'get', $headers = [], $data = [], $json = false)
    {
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        if ($method === 'post') {
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        }
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_HEADER, true);
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
        if ($json && is_array($result)) {
            return json_encode($result);
        } else if (!$json && !is_array($result)) {
            return json_decode($result, true);
        } else {
            return $result;
        }
    }

    public static function showDate($date)
    {
        $stf = 0;
        $cur_time = time();
        $diff = $cur_time - $date;

        $seconds = array('секунда', 'секунды', 'секунд');
        $minutes = array('минута', 'минуты', 'минут');
        $hours = array('час', 'часа', 'часов');
        $days = array('день', 'дня', 'дней');
        $weeks = array('неделя', 'недели', 'недель');
        $months = array('месяц', 'месяца', 'месяцев');
        $years = array('год', 'года', 'лет');
        $decades = array('десятилетие', 'десятилетия', 'десятилетий');
        $phrase = array($seconds, $minutes, $hours, $days, $weeks, $months, $years, $decades);
        $length = array(1, 60, 3600, 86400, 604800, 2630880, 31570560, 315705600);

        for ($i = sizeof($length) - 1; ($i >= 0) && (($no = $diff / $length[$i]) <= 1); $i--) {
            ;
        }
        if ($i < 0) {
            $i = 0;
        }
        $_time = $cur_time - ($diff % $length[$i]);
        $no = floor($no);
        $value = sprintf("%d %s ", $no, self::getPhrase($no, $phrase[$i]));

        if (($stf == 1) && ($i >= 1) && (($cur_time - $_time) > 0)) {
            $value .= time_ago($_time);
        }

        return $value . ' назад';
    }

    public static function alnum($string)
    {
        return preg_replace('/[^[:alnum:]]/', '', $string);
    }

    private static function getPhrase($number, $titles)
    {
        $cases = array(2, 0, 1, 1, 1, 2);
        return $titles[($number % 100 > 4 && $number % 100 < 20) ? 2 : $cases[min($number % 10, 5)]];
    }

    public static function tips()
    {
		if (\g::ml()->checkModule('Tips')) {
            $name = \g::response()->data()->get('name');
            if ($name) {
				$name = preg_replace('/\pP/iu', '', $name);
				$arrayName = explode(' ', $name);
				$where = array();
				foreach ($arrayName as $key => $value) {
					if (mb_strlen($value) < 3) continue;
					$where[] = "`tags` LIKE '%".$value."%'";
				}
				$sql_where = (count($where) > 0) ? implode(' OR ', $where) : "tags = ''";
				$query = \g::db()->query("SELECT content FROM tips WHERE ".$sql_where." ORDER BY RAND() LIMIT 1");
				if (!$query->num_rows) {
					$query = \g::db()->query("SELECT content FROM tips WHERE tags = '' ORDER BY RAND() LIMIT 1");
				}
            } else {
                $query = \g::db()->query("SELECT content FROM tips WHERE tags = '' ORDER BY RAND() LIMIT 1");
            }
            $content = '';
            if ($query->num_rows > 0) {
                $content = $query->fetch_row()[0];
            }
            \g::response()->data()->set('tip', stripcslashes(htmlspecialchars_decode(self::mask($content))));
			return \g::response()->data()->get('tip');
        }
    }

    public static function similar()
    {
        $name = \g::response()->data()->get('name');
		$view_similar_pages = \g::settings('view_similar_pages');
		$view_similar_products = \g::settings('view_similar_products');
		if ($view_similar_pages == 1 && method_exists(\g::module('Pages'), 'similarPages')) {
			$pages_result = \g::Pages()->similarPages($name);
		} else $pages_result['html'] = [];
		if ($view_similar_products == 1 && \g::ml()->checkModule('Catalog')) {
			$products_result = \g::Catalog()->similarProducts($name);
		} else $products_result['html'] = [];
        if (count($pages_result) > 0 OR count($products_result) > 0) {
			$result = array_merge($pages_result['html'],$products_result['html']);
            \g::response()->data()->set('html', $result);
            \g::tp()->chunk('similar-pages');
        }
    }
}
