<?php
/*
v12
*/
class g
{
	
    private static $_stack = null;
    private static $_request = null;
    private static $_response = null;
    private static $_db = null;
    private static $_count = 0;
    private static $_catalog = null;
    private static $_pages = null;
    private static $_forum = null;
    private static $_cart = null;
    private static $_tp = null;
    private static $_base = null;
    private static $_redis = null;
    private static $_settings = null;
    private static $_reviews = null;
    private static $_cache = null;
    private static $_logers = null;
    private static $_modules = null;
    private static $_module_loader = null;
    private static $_validate = null;
    private static $_SERVER = null;

    public static function get($name = null)
    {
        if (\g::request()->post()->get($name))
            return \g::request()->post()->get($name);

        return \g::request()->get()->get($name);
    }

    public static function send($param = [])
    {
        \g::response()->data()->set($param);
    }

    public static function db()
    {
        if (is_null(self::$_db)) {
            self::$_db = new \core\SafeMySQL(include ROOT . '/config/db.php');
        }
        self::$_count++;
        return self::$_db;
    }

    public static function stack()
    {
        if (is_null(self::$_stack)) {
            self::$_stack = new \globals\Stack;
        }
        return self::$_stack;
    }

    public static function print($var)
    {
        static $int=0;
        echo '<pre style="border: 1px solid #ee5959; background: white; height: fit-content; padding: 0.5em; position: relative; z-index: 9999999;"><b style="background: #ee5959;padding: 1px 5px;">' .$int . '</b> ';
        print_r($var);
        echo '</pre>';
        $int++;
    }

    public static function request()
    {
        if (is_null(self::$_request)) {
            self::$_request = new \globals\Request;
        }
        return self::$_request;
    }

    public static function response()
    {
        if (is_null(self::$_response)) {
            self::$_response = new \globals\Response;
        }
        return self::$_response;
    }

    public static function tp()
    {
        if (is_null(self::$_tp)) {
            self::$_tp = new \globals\Template();
        }
        return self::$_tp;
    }

    public static function ml()
    {
        if (is_null(self::$_module_loader)) {
            self::$_module_loader = new \core\ModuleLoader('modules');
            self::$_module_loader->load();
        }
        return self::$_module_loader;
    }
    public static function getModuleTemplateInfo($name)
    {
        $name = \f::alnum($name);
        $file = ROOT . "/modules/$name/Module.php";
        if (file_exists($file)) {
            $files_data = (include $file);
            return $files_data['template'] ??= false;

        } else {
            return false;
        }
    }

    public static function module($name)
    {
        $name = \f::alnum($name);
        if (is_null(self::$_modules) || !isset(self::$_modules[$name])) {
            $file = ROOT . "/modules/$name/classes/$name.php";
            if (file_exists($file)) {
                include_once $file;
                self::$_modules[$name] = new $name();
            } else {
                return false;
            }
        }
        return self::$_modules[$name];
    }

    public static function base()
    {
        if (is_null(self::$_base)) {
            self::$_base = new \globals\Base();
            return self::$_base;
        }
        return self::$_base;
    }

    public static function redis()
    {
        if (is_null(self::$_redis)) {
            try {
                self::$_redis = new \Predis\Client();
                return self::$_redis;
            } catch (Exception $e) {
                die($e->getMessage());
            }
        }
        return self::$_redis;
    }

    public static function cache($module = '')
    {
        $_cache = new Cache\Cache(new Cache\Adapter\Filesystem(DIR . 'cache-dir'));
        return "";
    }

    public static function settings($key = "")
    {
		$settings = \f::readCache("settings");
		if( $settings ) {
			$settings = unserialize($settings);
			if ( !is_array($settings) ) return false;
			$cache = true;
		} else {
			
            $settings = [];
            $query = \g::db()->query("SELECT * FROM `settings` ORDER BY `id` ASC");
            if ($query->num_rows > 0) {
                $settings['base_url'] = [
                    'id' => 0,
                    'name' => 'base_url',
                    'val' => \g::request()->server()->getDomains(),
                    'placeholder' => 'Доменное имя',
                    'description' => 'Адрес сайта',
                    'label' => '',
                    'type' => 'text:disabled',
                    'modules' => 'settings'
                ];
                while ($row = $query->fetch_assoc()) {
                    $settings[$row['name']] = $row;
                }
            }
			$cache = false;

        }
		if (!$cache) \f::createCache("settings", serialize($settings) );
		
		if ($key == '') {
			return $settings;
		}
		return (isset($settings[$key]['name']) && $key == $settings[$key]['name']) ? $settings[$key]['val'] : false;
    }

    public static function validate()
    {
        if (is_null(self::$_validate)) {
            self::$_validate = new \globals\Validate();
        }
        return self::$_validate;
    }

    public static function server()
    {
        if (is_null(self::$_SERVER)) {
            self::$_SERVER = new \core\request\Server();
        }
        return self::$_SERVER;
    }

    public static function __callStatic($method, $args = [])
    {
        $d = true;
        foreach (str_split($method) as $char) {
            if (strtolower($char) !== $char) {
                $d = false;
            }
        }
        if ($d == true) $method = ucfirst(strtolower($method));
        $name = \f::alnum($method);

        if (is_null(self::$_modules) || !isset(self::$_modules[$name])) {
            if (!class_exists($name)) {
                $file = ROOT . "/modules/$name/classes/$name.php";
                if (file_exists($file)) {
                    include_once $file;
                    self::$_modules[$name] = new $name($args);
                } else {
                    return new EmptyObject();
                }
            } else {
                self::$_modules[$name] = new $name($args);
            }
        }
        return self::$_modules[$name];
    }
}

class EmptyObject
{
    public function __call($name, $arguments)
    {
        return false;
    }

    public static function __callStatic($name, $arguments)
    {
        return false;
    }
}
