<?php
namespace globals;

class Reviews
{
	public $pagination = false;
	public $limit = 10;
	public $start = 0;
	public $totalRecords = 0;
	public $totalPages = 0;
	public $activePage = 0;
	private $max_rating_stars = 5;

	public static function getPublicReviews__rating($parentId, $groupId = null) {
		if (is_null($groupId)) {
			$res = \g::db()->getRow('
				SELECT SUM(R.`value`) AS total_rating, SUM(R.`value`) / COUNT(R.`value`)  AS real_rating, COUNT(R.`value`) AS total_items
				FROM `reviews` AS R
				INNER JOIN `reviews_group` AS G ON G.`id` = R.`group_id`
				WHERE R.`confirm`=1 AND R.`parent_id`=?i AND G.`parent_table`=?s', intval($parentId), $this->parentTable
			);
		} else {
			$res = \g::db()->getRow('
				SELECT SUM(R.`value`) AS total_rating, SUM(R.`value`) / COUNT(R.`value`)  AS real_rating, COUNT(R.`value`) AS total_items
				FROM `reviews` AS R
				INNER JOIN `reviews_group` AS G ON G.`id` = R.`group_id`
				WHERE R.`confirm`=1 AND R.`parent_id`=?i AND R.`group_id`=?i', intval($parentId), intval($groupId)
			);
		}
		$rating = $res;
		$rating['max_rating'] = $this->$max_rating_stars;
		$rating['rating_format'] = '0/' . $rating['max_rating'];
		
		if ($rating['real_rating'] > 0) {
			$rating['real_rating'] = number_format($rating['real_rating'], 1, '.','');
			$rating['rating_format'] = $rating['real_rating'] . '/' . $rating['max_rating'];
		}
		return $rating;
	}

	public function getPublicReviews($groupId, $parentId = null) {
		$rows = [];

		$page = (int)(isset($_GET['page']) ? $_GET['page'] : 0);

		if (!is_numeric($page))
			$page = 1;

		$startPage = ($page !=0 ) ? $page - 1 : 0;
		$this->activePage = $page;
		$this->start = $startPage * $this->limit;

		if (is_null($parentId)) {
			$res = \g::db()->query('
				SELECT R.*,G.`id` AS group_id, G.`name` AS `group_name`
				FROM `reviews` R
				INNER JOIN `reviews_group` G ON G.`id` = R.`group_id`
				WHERE R.`confirm`=1 AND R.`group_id`=?i AND `R`.`parent_id` = 0
				ORDER BY R.`time` DESC', intval($groupId)
			);
			$this->totalRecords = $res->num_rows;
			$this->totalPages = ceil($this->totalRecords / $this->limit);
			$res = \g::db()->query('
				SELECT R.*,G.`id` AS group_id, G.`name` AS `group_name`
				FROM `reviews` R
				INNER JOIN `reviews_group` G ON G.`id` = R.`group_id`
				WHERE R.`confirm`=1 AND R.`group_id`=?i AND `R`.`parent_id` = 0
				ORDER BY R.`time` DESC LIMIT '.$this->start.', '.$this->limit, intval($groupId)
			);
		} else {
			$res = \g::db()->query('
				SELECT R.*,G.`id` AS group_id, G.`name` AS `group_name`
				FROM `reviews` R
				INNER JOIN `reviews_group` G ON G.`id` = R.`group_id`
				WHERE R.`confirm`=1 AND R.`group_id`=?i  AND `R`.`parent_id` = ?i
				ORDER BY R.`time` DESC', intval($groupId), intval($parentId)
			);
		}

		if ($this->totalPages > 1)
			$this->pagination = true;
		else 
			$this->pagination = false;

		while ($row = mysqli_fetch_assoc($res)) {	
			$form = unserialize(stripslashes($row['form']));
			unset($row['form']);
			$row['name'] = isset($form['name']) ? $form['name'] : 'Аноним';
			$row['comment_short'] = mb_strimwidth($form['message'], 0, 200, "...");
			$row['comment_full'] = strip_tags($form['message']);
			$row['full_comment_btn'] = (strlen($form['message']) > 200) ? true : false;
			$row['fio'] = (isset($form['fullname']) ? $form['fullname'] : '');
			$row['status_formatted'] = ($row['confirm'] == true) ? 'Опубликован' : 'Неопубликован';
			$row['show_confirm_btn'] = ($row['confirm'] == false) ? true : false; 
			$row['email'] = $form['email'];
			$row['rating_star'] = ($row['value'] != 0) ? intval($row['value']) : 0;
			$row['date_formatted'] = (date('Y-m-d') == date('Y-m-d', $row['time'])) ? 'Сегодня о '.date('H:i', $row['time']) : strftime('%e %h %Y года о %H:%M', $row['time']);
			$rows[] = $row;
		}
		return $rows;
	}
}