<?php
namespace globals;

class Stack
{
	private $_stack = [];

	public function get($key = null) {
		if (is_null($key)) {
			return $this->_stack;
		}
		return $this->isCheckExistence($key) ? $this->_stack[$key] : false;
	}

	public function set($key, $data = null) {
		if (is_array($key) && is_null($data)) {
			foreach ($key as $k => $v) {
				$this->_stack[$k] = $v;
			}
			return true;
		}

		if (is_array($data)) {
			foreach ($data as $k => $v) {
				$this->_stack[$key][$k] = $v;
			}
			return true;
		}

		if ($this->isCheckExistence($key)) {
			return false;
		}
		$this->_stack[$key] = $data;
		return true;
	}

	public function update($key, $data) {
		if ($this->isCheckExistence($key)) {
			$this->_stack[$key] = $data;
			return true;
		}
		return false;
	}

	public function remove($key) {
		if ($this->isCheckExistence($key)) {
			unset($this->_stack[$key]);
			return true;
		}
		return false;
	}

	public function isCheckExistence($key) {
		return isset($this->_stack[$key]);
	}
}
