let CKEDITORConfig = {
    toolbarGroups: [
        {name: 'document', groups: ['mode', 'document', 'doctools']},
        {name: 'styles', groups: ['styles']},
        {name: 'colors', groups: ['colors']},
        {name: 'paragraph', groups: ['indent', 'blocks', 'align', 'list', 'bidi', 'paragraph']},
        {name: 'clipboard', groups: ['clipboard', 'undo']},
        {name: 'basicstyles', groups: ['basicstyles', 'cleanup']},
        {name: 'links', groups: ['links']},
        {name: 'editing', groups: ['find', 'selection', 'spellchecker', 'editing']},
        {name: 'forms', groups: ['forms']},
        {name: 'insert', groups: ['insert']},
        {name: 'tools', groups: ['tools']},
        {name: 'others', groups: ['others']},
        {name: 'about', groups: ['about']}
    ],
    methods: {
        onDialogDefinition(evt) {
            console.log("onDialogDefinition");
        },
        selectedFiles(files) {
            console.log("selectedFiles");
        },
        closeFilesManager() {
            console.log("closeFilesManager");
        }
    },
    language: 'ru',
    allowedContent: true,
    allowedContentRules: true,
    width: '100%',
    removePlugins: "exportpdf",
    removeButtons: 'Subscript,Superscript,Save,NewPage,ExportPdf,Preview,Print,Templates,Cut,Copy,Paste,Styles,Outdent,Indent,CreateDiv,BidiLtr,BidiRtl,Language,Anchor,Find,Replace,SelectAll,Scayt,Form,Checkbox,Radio,TextField,Textarea,Select,Button,ImageButton,HiddenField,Iframe,PageBreak,SpecialChar,Smiley,HorizontalRule,ShowBlocks,About,Blockquote',
    filebrowserBrowseUrl: '/miwix/selectFiles',
};
let editor;
$(document).ready(function () {

    if (document.getElementById("kt_docs_ckeditor_classic")) {
        CKEDITOR.replace('kt_docs_ckeditor_classic', CKEDITORConfig);
    }

    $('.pages-edit-form input[name="parent_name"]').click(function () {
		let name = $(this).attr('pages-catselect-name');
		let url = $(this).attr('pages-catselect-url');
		if (name && url) {
			$('.pages-edit-form input[name="parent_name"]').val(name);
			$('.pages-edit-form input[name="parent_name"]').attr('data-parent-url', url);
		}
        $('.pages-catselect-modal').modal('toggle');
        return false;
    });

    $('.pages-edit-form input[name="nav_parent_name"]').click(function () {
		let name = $(this).attr('pages-navselect-name');
		let url = $(this).attr('pages-navselect-url');
		if (name && url) {
			$('.pages-edit-form input[name="nav_parent_name"]').val(name);
			$('.pages-edit-form input[name="nav_parent_name"]').attr('data-nav-parent-url', url);
		}
        $('.pages-navselect-modal').modal('toggle');
        return false;
    });

});
let progress_size = 0;
let current_size = 0;

function hideLoader() {
    document.querySelector(".preloader").classList.add("hide")
}

function showLoader(data = {}) {
    if (data?.showBar) {
        document.querySelector(".preloader").classList.add("no-bar")
    } else {
        document.querySelector(".preloader").classList.remove("no-bar")
    }
    document.querySelector(".preloader").classList.remove("hide")
}

function incrementProgress() {
    current_size++;
    let elem_size = 100 / progress_size;

    let new_size = current_size * elem_size;
    document.querySelector("#progress_bar_progress").style.width = new_size + "%";
    document.querySelector(".c_progress_text").innerHTML = current_size + " / " + progress_size;

}

function setProgressSize(len) {
    current_size = 0;
    progress_size = len;
    document.querySelector("#progress_bar_progress").style.width = "0%";
    document.querySelector(".c_progress_text").innerHTML = "0 / " + progress_size;

}

function clearFullCash() {
    let url = "/miwix/settings/clearCacheBrowser";
    fetch(url, {
        method: 'POST',
        headers: {
            'x-miwix-json': 'true'
        },
    }).then(response => response.json())
        .then((data) => {
            let icons = "error";
            if (data['res'])
                icons = "success";
            Swal.fire({
                text: data['message'],
                icon: icons,
                showConfirmButton: false,
                timer: 1500
            });
            setTimeout(function () {
                location.reload()
            }, 1200);
        });
}

let DynamicFieldObject = null;

function setFieldObject(obj) {
    DynamicFieldObject = obj
}

function AddDynamicField() {
    FieldList.addFieldTemplate(dynamic_fields.template, () => {
        dynamic_fields.reload()
    })
}

function debounce(func = () => {
}, timeout = 500) {

    window.HW_timerDebounce = null;

    if (window.HW_timerDebounce)
        clearTimeout(window.HW_timerDebounce);
    window.HW_timerDebounce = setTimeout(() => {
        func();
    }, timeout)
}

var racerEvwntList = {};

function RacerOn(eventName, block, func) {
    if (!racerEvwntList[eventName]) {
        racerEvwntList[eventName] = {
            'func': eventPush,
            'list': {}
        }
        document.body.addEventListener(eventName, eventPush, false)
    }

    racerEvwntList[eventName]['list'][block] = func

    function eventPush(event) {
        let elem = []
        if (racerEvwntList[event.type]?.['list']) {
            Object.entries(racerEvwntList[event.type]?.['list']).forEach(entry => {
                const [element, funcElem] = entry
                if (!elem.includes(element)) {
                    elem.push(element)
                    push(element, event.target, funcElem, event)
                }
            })
        }
    }

    function push(block, target, func, event) {
        if (Array.prototype.indexOf.call(document.querySelectorAll(block), target) != -1) {
            event.preventDefault()
            func(target, event)
            return;
        }

        let target_next = target?.parentElement
        if (target_next)
            push(block, target_next, func, event)
    }
}

function setJobListSort(sendServer = true) {

    let elements = [];
    if (document.querySelector(".search-job-list").value)
        return false;

    document.querySelectorAll('.job_item').forEach((el, index) => {
        el.dataset.sort = index + 1;

        elements.push({
            id: el.dataset.id,
            sort: index + 1
        })
    })
    if (sendServer)
        debounce(() => {
            let data = new FormData();
            elements.forEach((el, index) => {
                data.append(`sort[${index}][id]`, el.id);
                data.append(`sort[${index}][sort]`, el.sort);
            })
            let url = '/miwix/main/setSortJob';

            fetch(url, {
                method: 'POST',
                headers: {
                    'x-miwix-json': 'true'
                },
                body: data
            }).then(response => response.json())
                .then((l) => {
                    //  renderJobList(l.data, false)
                });
        }, 700);

}

let job_list_global = {};
let disable_show = false;
new Sortable(document.querySelector('.job_list'), {
    animation: 150,
    ghostClass: 'blue-background-class',
    filter: '.block',
    onUpdate: () => {
        setJobListSort();
    }
});

RacerOn('input', ".search-job-list", (target) => {
    renderJobList(Object.values(job_list_global), false);
})

RacerOn('click', '.open_description', (target) => {
    document.querySelector('#kt_toolbar').classList.toggle('toolbar_open')
})

RacerOn('click', '.job_list_button', (target) => {
    document.querySelector('.job_list_block').classList.toggle('d-none')
})

RacerOn('click', '.header_search_button', (target) => {
    document.querySelector('.header_search_block').classList.toggle('d-none')
})

RacerOn('click', '.job_item_delete', (target) => {
    disable_show = true
    setTimeout(() => {
        disable_show = false
    }, 200)
    Swal.fire({
        title: 'Удалить?',
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#d33',
        cancelButtonColor: '#3085d6',
        cancelButtonText:
            'Отмена',
        confirmButtonText: 'Удалить'
    }).then((result) => {
        if (result.isConfirmed) {
	
			let data = new FormData();
			data.append("id", target.dataset.id);
			let url = '/miwix/main/deleteJob';

			fetch(url, {
				method: 'POST',
				headers: {
					'x-miwix-json': 'true'
				},
				body: data
			}).then(response => response.json())
				.then((l) => {
					document.querySelector(`.job_item[data-id="${target.dataset.id}"]`).remove()
					setJobListSort()
				});
        }
    })
})

RacerOn('click', '.job_item', (target) => {
    if (!disable_show) {
        Swal.fire({
            html: `
                <input data-id="${target.dataset.id}" id="job__name" type="text" class="form-control form-control-solid " value="${job_list_global[target.dataset.id].text.replaceAll(`\\`, "")}">
                <br>
				<textarea id="job__content" class="form-control form-control-solid dynamic-field" rows="15" placeholder="Информация">${job_list_global[target.dataset.id].content.replaceAll(`\\`, "")}</textarea>
			`,
            showCloseButton: true,
            focusConfirm: false,
            confirmButtonText: 'Обновить',
            preConfirm: () => {

                return {
                    'id': target.dataset.id,
                    'name': Swal.getPopup().querySelector('#job__name').value,
                    'content': Swal.getPopup().querySelector('#job__content').value,
                }
            }
        }).then((result) => {
            if (result.isConfirmed) {
                let data = new FormData();
                data.append("text", result.value.name.trim());
                data.append("id", result.value.id);
                data.append("content", result.value.content.trim());
                let url = '/miwix/main/UpdateJob';

                fetch(url, {
                    method: 'POST',
                    headers: {
                        'x-miwix-json': 'true'
                    },
                    body: data
                }).then(response => response.json())
                    .then((l) => {
                        document.querySelector(".search-job-list").value = '';
                        getJobList();
                    });
            }
        });
    }
})


RacerOn('click', '.job_item_add_button', (target) => {
    Swal.fire({
        title: 'Создание задачи. ',
        html: `
				<input id="job__name" class="form-control form-control-lg form-control-solid" type="text" placeholder="Имя задачи"><br>
				<textarea id="job__content" class="form-control form-control-solid dynamic-field" rows="9" placeholder="Информация"></textarea>
			`,
        confirmButtonText: 'Создать',
        showCloseButton: true,
        focusConfirm: false,
        preConfirm: () => {
            let variables = Swal.getPopup().querySelector('#job__name').value;
            if (!variables) {
                Swal.showValidationMessage('Введите имя');
            }

            return {
                'name': variables,
                'content': Swal.getPopup().querySelector('#job__content').value,
            }
        }
    }).then((result) => {
        if (result.isConfirmed) {
            let data = new FormData();
            data.append("text", result.value.name.trim());
            data.append("content", result.value.content.trim());
            let url = '/miwix/main/addJob';

            fetch(url, {
                method: 'POST',
                headers: {
                    'x-miwix-json': 'true'
                },
                body: data
            }).then(response => response.json())
                .then((l) => {
                    job_list_global[l.id] = {
                        id: l.id,
                        content: l.content,
                        text: l.text
                    }
                    document.querySelector(".job_list").innerHTML = `
                         <div data-id="${l.id}" class="job_item cursor-pointer"> 
                            <b>${l.text.replaceAll(`\\`, "")}</b> <br>
                             ${kitcut(l.content, 100)}                                                  
                            <div data-id="${l.id}" class="job_item_delete">
                                ✖
                            </div>
                         </div>
                    ` + document.querySelector(".job_list").innerHTML

                    setJobListSort();
                });
        }
    });
})

function kitcut(text, limit) {
    if (!text)
        return text;
    text = text.trim().replaceAll(`\\`, "");
	
    if (text.length <= limit) return text;

    text = text.slice(0, limit);

    return text.trim() + "...";
}


function renderJobList(data, sendServer = true) {
    document.querySelector(".job_list").innerHTML = ``
    data.forEach(el => {
        job_list_global[el.id] = {
            id: el.id,
            content: el.content,
            text: el.text
        }
					
        if (document.querySelector(".search-job-list").value) {
            if (el.text.toLowerCase().indexOf(document.querySelector(".search-job-list").value.toLowerCase()) !== -1) {
                document.querySelector(".job_list").innerHTML += `
                     <div data-id="${el.id}" class="job_item cursor-pointer block">
                         <b>${el.text.replaceAll(`\\`, "")}</b> <br>
                         ${kitcut(el.content, 100)}           
                        <div data-id="${el.id}" class="job_item_delete">
                            ✖
                        </div>
                     </div>
                    `
            }
        } else {
            document.querySelector(".job_list").innerHTML += `
                     <div data-id="${el.id}" class="job_item cursor-pointer">
                         <b>${el.text.replaceAll(`\\`, "")}</b> <br>
                         ${kitcut(el.content, 100)}           
                        <div data-id="${el.id}" class="job_item_delete">
                            ✖
                        </div>
                     </div>
                    `
        }


    })

    setJobListSort(sendServer);
}
getJobList();
function getJobList()
{
    fetch('/miwix/main/getJobs', {
        headers: {
            'x-miwix-json': 'true'
        },
    }).then(response => response.json())
        .then((l) => {
            renderJobList(l.data, false)
        });
}
